#include "vectors.h"

#include <math.h>

namespace maths
{
	/////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////// Lengths //////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////
	
	// square lenght
	float Vector2F::getSquareLength()
	{
		squareLength = x * x + y * y;
		return squareLength;
	}

	// length
	float Vector2F::getLength()
	{
		length = sqrtf(x * x + y * y);
		return length;
	}

	/////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////// Normalize ////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////
	void Vector2F::normalize(float l)
	{
		if (l == -1)
		{
			// no length provided -> compute it
			l = getLength();
		}

		// normalize vector
		x = x / l;
		y = y / l;
	}

	/////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////// Operators ////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////
	Vector2F& Vector2F::operator*=(const float a)
	{
		x *= a;
		y *= a;

		return *this;
	}

}